// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from etsi_its_denm_ts_msgs:msg/EventPoint.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "etsi_its_denm_ts_msgs/msg/detail/event_point__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void EventPoint_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) etsi_its_denm_ts_msgs::msg::EventPoint(_init);
}

void EventPoint_fini_function(void * message_memory)
{
  auto typed_message = static_cast<etsi_its_denm_ts_msgs::msg::EventPoint *>(message_memory);
  typed_message->~EventPoint();
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember EventPoint_message_member_array[4] = {
  {
    "event_position",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<etsi_its_denm_ts_msgs::msg::DeltaReferencePosition>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_denm_ts_msgs::msg::EventPoint, event_position),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "event_delta_time",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<etsi_its_denm_ts_msgs::msg::PathDeltaTime>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_denm_ts_msgs::msg::EventPoint, event_delta_time),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "event_delta_time_is_present",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_BOOLEAN,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_denm_ts_msgs::msg::EventPoint, event_delta_time_is_present),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "information_quality",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<etsi_its_denm_ts_msgs::msg::InformationQuality>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_denm_ts_msgs::msg::EventPoint, information_quality),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers EventPoint_message_members = {
  "etsi_its_denm_ts_msgs::msg",  // message namespace
  "EventPoint",  // message name
  4,  // number of fields
  sizeof(etsi_its_denm_ts_msgs::msg::EventPoint),
  EventPoint_message_member_array,  // message members
  EventPoint_init_function,  // function to initialize message memory (memory has to be allocated)
  EventPoint_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t EventPoint_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &EventPoint_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<etsi_its_denm_ts_msgs::msg::EventPoint>()
{
  return &::etsi_its_denm_ts_msgs::msg::rosidl_typesupport_introspection_cpp::EventPoint_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, etsi_its_denm_ts_msgs, msg, EventPoint)() {
  return &::etsi_its_denm_ts_msgs::msg::rosidl_typesupport_introspection_cpp::EventPoint_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
