// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_denm_ts_msgs:msg/MetaInformation.idl
// generated code does not contain a copyright notice
#include "etsi_its_denm_ts_msgs/msg/detail/meta_information__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `used_detection_information`
#include "etsi_its_denm_ts_msgs/msg/detail/sensor_types__functions.h"
// Member `used_stored_information`
#include "etsi_its_denm_ts_msgs/msg/detail/stored_information_type__functions.h"
// Member `confidence_value`
#include "etsi_its_denm_ts_msgs/msg/detail/confidence_level__functions.h"

bool
etsi_its_denm_ts_msgs__msg__MetaInformation__init(etsi_its_denm_ts_msgs__msg__MetaInformation * msg)
{
  if (!msg) {
    return false;
  }
  // used_detection_information
  if (!etsi_its_denm_ts_msgs__msg__SensorTypes__init(&msg->used_detection_information)) {
    etsi_its_denm_ts_msgs__msg__MetaInformation__fini(msg);
    return false;
  }
  // used_stored_information
  if (!etsi_its_denm_ts_msgs__msg__StoredInformationType__init(&msg->used_stored_information)) {
    etsi_its_denm_ts_msgs__msg__MetaInformation__fini(msg);
    return false;
  }
  // confidence_value
  if (!etsi_its_denm_ts_msgs__msg__ConfidenceLevel__init(&msg->confidence_value)) {
    etsi_its_denm_ts_msgs__msg__MetaInformation__fini(msg);
    return false;
  }
  // confidence_value_is_present
  return true;
}

void
etsi_its_denm_ts_msgs__msg__MetaInformation__fini(etsi_its_denm_ts_msgs__msg__MetaInformation * msg)
{
  if (!msg) {
    return;
  }
  // used_detection_information
  etsi_its_denm_ts_msgs__msg__SensorTypes__fini(&msg->used_detection_information);
  // used_stored_information
  etsi_its_denm_ts_msgs__msg__StoredInformationType__fini(&msg->used_stored_information);
  // confidence_value
  etsi_its_denm_ts_msgs__msg__ConfidenceLevel__fini(&msg->confidence_value);
  // confidence_value_is_present
}

bool
etsi_its_denm_ts_msgs__msg__MetaInformation__are_equal(const etsi_its_denm_ts_msgs__msg__MetaInformation * lhs, const etsi_its_denm_ts_msgs__msg__MetaInformation * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // used_detection_information
  if (!etsi_its_denm_ts_msgs__msg__SensorTypes__are_equal(
      &(lhs->used_detection_information), &(rhs->used_detection_information)))
  {
    return false;
  }
  // used_stored_information
  if (!etsi_its_denm_ts_msgs__msg__StoredInformationType__are_equal(
      &(lhs->used_stored_information), &(rhs->used_stored_information)))
  {
    return false;
  }
  // confidence_value
  if (!etsi_its_denm_ts_msgs__msg__ConfidenceLevel__are_equal(
      &(lhs->confidence_value), &(rhs->confidence_value)))
  {
    return false;
  }
  // confidence_value_is_present
  if (lhs->confidence_value_is_present != rhs->confidence_value_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__MetaInformation__copy(
  const etsi_its_denm_ts_msgs__msg__MetaInformation * input,
  etsi_its_denm_ts_msgs__msg__MetaInformation * output)
{
  if (!input || !output) {
    return false;
  }
  // used_detection_information
  if (!etsi_its_denm_ts_msgs__msg__SensorTypes__copy(
      &(input->used_detection_information), &(output->used_detection_information)))
  {
    return false;
  }
  // used_stored_information
  if (!etsi_its_denm_ts_msgs__msg__StoredInformationType__copy(
      &(input->used_stored_information), &(output->used_stored_information)))
  {
    return false;
  }
  // confidence_value
  if (!etsi_its_denm_ts_msgs__msg__ConfidenceLevel__copy(
      &(input->confidence_value), &(output->confidence_value)))
  {
    return false;
  }
  // confidence_value_is_present
  output->confidence_value_is_present = input->confidence_value_is_present;
  return true;
}

etsi_its_denm_ts_msgs__msg__MetaInformation *
etsi_its_denm_ts_msgs__msg__MetaInformation__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__MetaInformation * msg = (etsi_its_denm_ts_msgs__msg__MetaInformation *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__MetaInformation), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_denm_ts_msgs__msg__MetaInformation));
  bool success = etsi_its_denm_ts_msgs__msg__MetaInformation__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_denm_ts_msgs__msg__MetaInformation__destroy(etsi_its_denm_ts_msgs__msg__MetaInformation * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_denm_ts_msgs__msg__MetaInformation__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence__init(etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__MetaInformation * data = NULL;

  if (size) {
    data = (etsi_its_denm_ts_msgs__msg__MetaInformation *)allocator.zero_allocate(size, sizeof(etsi_its_denm_ts_msgs__msg__MetaInformation), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_denm_ts_msgs__msg__MetaInformation__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_denm_ts_msgs__msg__MetaInformation__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence__fini(etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_denm_ts_msgs__msg__MetaInformation__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence *
etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence * array = (etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence__destroy(etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence__are_equal(const etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence * lhs, const etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__MetaInformation__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence__copy(
  const etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence * input,
  etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_denm_ts_msgs__msg__MetaInformation);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_denm_ts_msgs__msg__MetaInformation * data =
      (etsi_its_denm_ts_msgs__msg__MetaInformation *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_denm_ts_msgs__msg__MetaInformation__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_denm_ts_msgs__msg__MetaInformation__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__MetaInformation__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
