// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/MetaInformation.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__META_INFORMATION__STRUCT_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__META_INFORMATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'used_detection_information'
#include "etsi_its_denm_ts_msgs/msg/detail/sensor_types__struct.hpp"
// Member 'used_stored_information'
#include "etsi_its_denm_ts_msgs/msg/detail/stored_information_type__struct.hpp"
// Member 'confidence_value'
#include "etsi_its_denm_ts_msgs/msg/detail/confidence_level__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__MetaInformation __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__MetaInformation __declspec(deprecated)
#endif

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MetaInformation_
{
  using Type = MetaInformation_<ContainerAllocator>;

  explicit MetaInformation_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : used_detection_information(_init),
    used_stored_information(_init),
    confidence_value(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->confidence_value_is_present = false;
    }
  }

  explicit MetaInformation_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : used_detection_information(_alloc, _init),
    used_stored_information(_alloc, _init),
    confidence_value(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->confidence_value_is_present = false;
    }
  }

  // field types and members
  using _used_detection_information_type =
    etsi_its_denm_ts_msgs::msg::SensorTypes_<ContainerAllocator>;
  _used_detection_information_type used_detection_information;
  using _used_stored_information_type =
    etsi_its_denm_ts_msgs::msg::StoredInformationType_<ContainerAllocator>;
  _used_stored_information_type used_stored_information;
  using _confidence_value_type =
    etsi_its_denm_ts_msgs::msg::ConfidenceLevel_<ContainerAllocator>;
  _confidence_value_type confidence_value;
  using _confidence_value_is_present_type =
    bool;
  _confidence_value_is_present_type confidence_value_is_present;

  // setters for named parameter idiom
  Type & set__used_detection_information(
    const etsi_its_denm_ts_msgs::msg::SensorTypes_<ContainerAllocator> & _arg)
  {
    this->used_detection_information = _arg;
    return *this;
  }
  Type & set__used_stored_information(
    const etsi_its_denm_ts_msgs::msg::StoredInformationType_<ContainerAllocator> & _arg)
  {
    this->used_stored_information = _arg;
    return *this;
  }
  Type & set__confidence_value(
    const etsi_its_denm_ts_msgs::msg::ConfidenceLevel_<ContainerAllocator> & _arg)
  {
    this->confidence_value = _arg;
    return *this;
  }
  Type & set__confidence_value_is_present(
    const bool & _arg)
  {
    this->confidence_value_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_denm_ts_msgs::msg::MetaInformation_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_ts_msgs::msg::MetaInformation_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::MetaInformation_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::MetaInformation_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::MetaInformation_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::MetaInformation_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::MetaInformation_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::MetaInformation_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::MetaInformation_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::MetaInformation_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__MetaInformation
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::MetaInformation_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__MetaInformation
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::MetaInformation_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MetaInformation_ & other) const
  {
    if (this->used_detection_information != other.used_detection_information) {
      return false;
    }
    if (this->used_stored_information != other.used_stored_information) {
      return false;
    }
    if (this->confidence_value != other.confidence_value) {
      return false;
    }
    if (this->confidence_value_is_present != other.confidence_value_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const MetaInformation_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MetaInformation_

// alias to use template instance with default allocator
using MetaInformation =
  etsi_its_denm_ts_msgs::msg::MetaInformation_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__META_INFORMATION__STRUCT_HPP_
