// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/RoadConfigurationContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_CONFIGURATION_CONTAINER__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_CONFIGURATION_CONTAINER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'road_configuration_confidence'
#include "etsi_its_denm_ts_msgs/msg/detail/meta_information__struct.h"
// Member 'road_configuration_section_list'
#include "etsi_its_denm_ts_msgs/msg/detail/road_configuration_section_list__struct.h"

/// Struct defined in msg/RoadConfigurationContainer in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__RoadConfigurationContainer
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This type contains detailed information about the configuration of road section(s) that are geographically related to the event.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field roadConfigurationConfidence: information about the source of the road configuration and the confidence in the information.
  ///  *
  ///  * @field roadConfigurationSectionList: a list of road configuration information per applicable road section.
  /// *
  /// */
  /// RoadConfigurationContainer ::=  SEQUENCE {
  ///     roadConfigurationConfidence     MetaInformation,
  ///     roadConfigurationSectionList    RoadConfigurationSectionList,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_ts_msgs__msg__MetaInformation road_configuration_confidence;
  etsi_its_denm_ts_msgs__msg__RoadConfigurationSectionList road_configuration_section_list;
} etsi_its_denm_ts_msgs__msg__RoadConfigurationContainer;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__RoadConfigurationContainer.
typedef struct etsi_its_denm_ts_msgs__msg__RoadConfigurationContainer__Sequence
{
  etsi_its_denm_ts_msgs__msg__RoadConfigurationContainer * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__RoadConfigurationContainer__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_CONFIGURATION_CONTAINER__STRUCT_H_
