// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/StationaryVehicleContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__STATIONARY_VEHICLE_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__STATIONARY_VEHICLE_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_ts_msgs/msg/detail/stationary_vehicle_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'stationary_since'
#include "etsi_its_denm_ts_msgs/msg/detail/stationary_since__traits.hpp"
// Member 'stationary_cause'
#include "etsi_its_denm_ts_msgs/msg/detail/cause_code_v2__traits.hpp"
// Member 'carrying_dangerous_goods'
#include "etsi_its_denm_ts_msgs/msg/detail/dangerous_goods_extended__traits.hpp"
// Member 'number_of_occupants'
#include "etsi_its_denm_ts_msgs/msg/detail/number_of_occupants__traits.hpp"
// Member 'vehicle_identification'
#include "etsi_its_denm_ts_msgs/msg/detail/vehicle_identification__traits.hpp"
// Member 'energy_storage_type'
#include "etsi_its_denm_ts_msgs/msg/detail/energy_storage_type__traits.hpp"

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const StationaryVehicleContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: stationary_since
  {
    out << "stationary_since: ";
    to_flow_style_yaml(msg.stationary_since, out);
    out << ", ";
  }

  // member: stationary_since_is_present
  {
    out << "stationary_since_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.stationary_since_is_present, out);
    out << ", ";
  }

  // member: stationary_cause
  {
    out << "stationary_cause: ";
    to_flow_style_yaml(msg.stationary_cause, out);
    out << ", ";
  }

  // member: stationary_cause_is_present
  {
    out << "stationary_cause_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.stationary_cause_is_present, out);
    out << ", ";
  }

  // member: carrying_dangerous_goods
  {
    out << "carrying_dangerous_goods: ";
    to_flow_style_yaml(msg.carrying_dangerous_goods, out);
    out << ", ";
  }

  // member: carrying_dangerous_goods_is_present
  {
    out << "carrying_dangerous_goods_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.carrying_dangerous_goods_is_present, out);
    out << ", ";
  }

  // member: number_of_occupants
  {
    out << "number_of_occupants: ";
    to_flow_style_yaml(msg.number_of_occupants, out);
    out << ", ";
  }

  // member: number_of_occupants_is_present
  {
    out << "number_of_occupants_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.number_of_occupants_is_present, out);
    out << ", ";
  }

  // member: vehicle_identification
  {
    out << "vehicle_identification: ";
    to_flow_style_yaml(msg.vehicle_identification, out);
    out << ", ";
  }

  // member: vehicle_identification_is_present
  {
    out << "vehicle_identification_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.vehicle_identification_is_present, out);
    out << ", ";
  }

  // member: energy_storage_type
  {
    out << "energy_storage_type: ";
    to_flow_style_yaml(msg.energy_storage_type, out);
    out << ", ";
  }

  // member: energy_storage_type_is_present
  {
    out << "energy_storage_type_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.energy_storage_type_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const StationaryVehicleContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: stationary_since
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stationary_since:\n";
    to_block_style_yaml(msg.stationary_since, out, indentation + 2);
  }

  // member: stationary_since_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stationary_since_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.stationary_since_is_present, out);
    out << "\n";
  }

  // member: stationary_cause
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stationary_cause:\n";
    to_block_style_yaml(msg.stationary_cause, out, indentation + 2);
  }

  // member: stationary_cause_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stationary_cause_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.stationary_cause_is_present, out);
    out << "\n";
  }

  // member: carrying_dangerous_goods
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "carrying_dangerous_goods:\n";
    to_block_style_yaml(msg.carrying_dangerous_goods, out, indentation + 2);
  }

  // member: carrying_dangerous_goods_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "carrying_dangerous_goods_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.carrying_dangerous_goods_is_present, out);
    out << "\n";
  }

  // member: number_of_occupants
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "number_of_occupants:\n";
    to_block_style_yaml(msg.number_of_occupants, out, indentation + 2);
  }

  // member: number_of_occupants_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "number_of_occupants_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.number_of_occupants_is_present, out);
    out << "\n";
  }

  // member: vehicle_identification
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vehicle_identification:\n";
    to_block_style_yaml(msg.vehicle_identification, out, indentation + 2);
  }

  // member: vehicle_identification_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vehicle_identification_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.vehicle_identification_is_present, out);
    out << "\n";
  }

  // member: energy_storage_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "energy_storage_type:\n";
    to_block_style_yaml(msg.energy_storage_type, out, indentation + 2);
  }

  // member: energy_storage_type_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "energy_storage_type_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.energy_storage_type_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const StationaryVehicleContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer & msg)
{
  return etsi_its_denm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer>()
{
  return "etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer";
}

template<>
inline const char * name<etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer>()
{
  return "etsi_its_denm_ts_msgs/msg/StationaryVehicleContainer";
}

template<>
struct has_fixed_size<etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_ts_msgs::msg::CauseCodeV2>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::DangerousGoodsExtended>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::EnergyStorageType>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::NumberOfOccupants>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::StationarySince>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::VehicleIdentification>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_ts_msgs::msg::CauseCodeV2>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::DangerousGoodsExtended>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::EnergyStorageType>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::NumberOfOccupants>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::StationarySince>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::VehicleIdentification>::value> {};

template<>
struct is_message<etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__STATIONARY_VEHICLE_CONTAINER__TRAITS_HPP_
