// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/EventPoint.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__EVENT_POINT__TRAITS_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__EVENT_POINT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_ts_msgs/msg/detail/event_point__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'event_position'
#include "etsi_its_denm_ts_msgs/msg/detail/delta_reference_position__traits.hpp"
// Member 'event_delta_time'
#include "etsi_its_denm_ts_msgs/msg/detail/path_delta_time__traits.hpp"
// Member 'information_quality'
#include "etsi_its_denm_ts_msgs/msg/detail/information_quality__traits.hpp"

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const EventPoint & msg,
  std::ostream & out)
{
  out << "{";
  // member: event_position
  {
    out << "event_position: ";
    to_flow_style_yaml(msg.event_position, out);
    out << ", ";
  }

  // member: event_delta_time
  {
    out << "event_delta_time: ";
    to_flow_style_yaml(msg.event_delta_time, out);
    out << ", ";
  }

  // member: event_delta_time_is_present
  {
    out << "event_delta_time_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.event_delta_time_is_present, out);
    out << ", ";
  }

  // member: information_quality
  {
    out << "information_quality: ";
    to_flow_style_yaml(msg.information_quality, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const EventPoint & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: event_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_position:\n";
    to_block_style_yaml(msg.event_position, out, indentation + 2);
  }

  // member: event_delta_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_delta_time:\n";
    to_block_style_yaml(msg.event_delta_time, out, indentation + 2);
  }

  // member: event_delta_time_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_delta_time_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.event_delta_time_is_present, out);
    out << "\n";
  }

  // member: information_quality
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "information_quality:\n";
    to_block_style_yaml(msg.information_quality, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const EventPoint & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_ts_msgs::msg::EventPoint & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_ts_msgs::msg::EventPoint & msg)
{
  return etsi_its_denm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_ts_msgs::msg::EventPoint>()
{
  return "etsi_its_denm_ts_msgs::msg::EventPoint";
}

template<>
inline const char * name<etsi_its_denm_ts_msgs::msg::EventPoint>()
{
  return "etsi_its_denm_ts_msgs/msg/EventPoint";
}

template<>
struct has_fixed_size<etsi_its_denm_ts_msgs::msg::EventPoint>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_ts_msgs::msg::DeltaReferencePosition>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::InformationQuality>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::PathDeltaTime>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_ts_msgs::msg::EventPoint>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_ts_msgs::msg::DeltaReferencePosition>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::InformationQuality>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::PathDeltaTime>::value> {};

template<>
struct is_message<etsi_its_denm_ts_msgs::msg::EventPoint>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__EVENT_POINT__TRAITS_HPP_
