// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_denm_ts_msgs:msg/MapemElementReference.idl
// generated code does not contain a copyright notice
#include "etsi_its_denm_ts_msgs/msg/detail/mapem_element_reference__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `map_reference`
#include "etsi_its_denm_ts_msgs/msg/detail/map_reference__functions.h"
// Member `lane_ids`
#include "etsi_its_denm_ts_msgs/msg/detail/mapem_lane_list__functions.h"
// Member `connection_ids`
#include "etsi_its_denm_ts_msgs/msg/detail/mapem_connection_list__functions.h"

bool
etsi_its_denm_ts_msgs__msg__MapemElementReference__init(etsi_its_denm_ts_msgs__msg__MapemElementReference * msg)
{
  if (!msg) {
    return false;
  }
  // map_reference
  if (!etsi_its_denm_ts_msgs__msg__MapReference__init(&msg->map_reference)) {
    etsi_its_denm_ts_msgs__msg__MapemElementReference__fini(msg);
    return false;
  }
  // map_reference_is_present
  // lane_ids
  if (!etsi_its_denm_ts_msgs__msg__MapemLaneList__init(&msg->lane_ids)) {
    etsi_its_denm_ts_msgs__msg__MapemElementReference__fini(msg);
    return false;
  }
  // lane_ids_is_present
  // connection_ids
  if (!etsi_its_denm_ts_msgs__msg__MapemConnectionList__init(&msg->connection_ids)) {
    etsi_its_denm_ts_msgs__msg__MapemElementReference__fini(msg);
    return false;
  }
  // connection_ids_is_present
  return true;
}

void
etsi_its_denm_ts_msgs__msg__MapemElementReference__fini(etsi_its_denm_ts_msgs__msg__MapemElementReference * msg)
{
  if (!msg) {
    return;
  }
  // map_reference
  etsi_its_denm_ts_msgs__msg__MapReference__fini(&msg->map_reference);
  // map_reference_is_present
  // lane_ids
  etsi_its_denm_ts_msgs__msg__MapemLaneList__fini(&msg->lane_ids);
  // lane_ids_is_present
  // connection_ids
  etsi_its_denm_ts_msgs__msg__MapemConnectionList__fini(&msg->connection_ids);
  // connection_ids_is_present
}

bool
etsi_its_denm_ts_msgs__msg__MapemElementReference__are_equal(const etsi_its_denm_ts_msgs__msg__MapemElementReference * lhs, const etsi_its_denm_ts_msgs__msg__MapemElementReference * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // map_reference
  if (!etsi_its_denm_ts_msgs__msg__MapReference__are_equal(
      &(lhs->map_reference), &(rhs->map_reference)))
  {
    return false;
  }
  // map_reference_is_present
  if (lhs->map_reference_is_present != rhs->map_reference_is_present) {
    return false;
  }
  // lane_ids
  if (!etsi_its_denm_ts_msgs__msg__MapemLaneList__are_equal(
      &(lhs->lane_ids), &(rhs->lane_ids)))
  {
    return false;
  }
  // lane_ids_is_present
  if (lhs->lane_ids_is_present != rhs->lane_ids_is_present) {
    return false;
  }
  // connection_ids
  if (!etsi_its_denm_ts_msgs__msg__MapemConnectionList__are_equal(
      &(lhs->connection_ids), &(rhs->connection_ids)))
  {
    return false;
  }
  // connection_ids_is_present
  if (lhs->connection_ids_is_present != rhs->connection_ids_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__MapemElementReference__copy(
  const etsi_its_denm_ts_msgs__msg__MapemElementReference * input,
  etsi_its_denm_ts_msgs__msg__MapemElementReference * output)
{
  if (!input || !output) {
    return false;
  }
  // map_reference
  if (!etsi_its_denm_ts_msgs__msg__MapReference__copy(
      &(input->map_reference), &(output->map_reference)))
  {
    return false;
  }
  // map_reference_is_present
  output->map_reference_is_present = input->map_reference_is_present;
  // lane_ids
  if (!etsi_its_denm_ts_msgs__msg__MapemLaneList__copy(
      &(input->lane_ids), &(output->lane_ids)))
  {
    return false;
  }
  // lane_ids_is_present
  output->lane_ids_is_present = input->lane_ids_is_present;
  // connection_ids
  if (!etsi_its_denm_ts_msgs__msg__MapemConnectionList__copy(
      &(input->connection_ids), &(output->connection_ids)))
  {
    return false;
  }
  // connection_ids_is_present
  output->connection_ids_is_present = input->connection_ids_is_present;
  return true;
}

etsi_its_denm_ts_msgs__msg__MapemElementReference *
etsi_its_denm_ts_msgs__msg__MapemElementReference__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__MapemElementReference * msg = (etsi_its_denm_ts_msgs__msg__MapemElementReference *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__MapemElementReference), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_denm_ts_msgs__msg__MapemElementReference));
  bool success = etsi_its_denm_ts_msgs__msg__MapemElementReference__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_denm_ts_msgs__msg__MapemElementReference__destroy(etsi_its_denm_ts_msgs__msg__MapemElementReference * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_denm_ts_msgs__msg__MapemElementReference__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence__init(etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__MapemElementReference * data = NULL;

  if (size) {
    data = (etsi_its_denm_ts_msgs__msg__MapemElementReference *)allocator.zero_allocate(size, sizeof(etsi_its_denm_ts_msgs__msg__MapemElementReference), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_denm_ts_msgs__msg__MapemElementReference__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_denm_ts_msgs__msg__MapemElementReference__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence__fini(etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_denm_ts_msgs__msg__MapemElementReference__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence *
etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence * array = (etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence__destroy(etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence__are_equal(const etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence * lhs, const etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__MapemElementReference__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence__copy(
  const etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence * input,
  etsi_its_denm_ts_msgs__msg__MapemElementReference__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_denm_ts_msgs__msg__MapemElementReference);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_denm_ts_msgs__msg__MapemElementReference * data =
      (etsi_its_denm_ts_msgs__msg__MapemElementReference *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_denm_ts_msgs__msg__MapemElementReference__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_denm_ts_msgs__msg__MapemElementReference__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__MapemElementReference__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
