// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/MetaInformation.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__META_INFORMATION__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__META_INFORMATION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'used_detection_information'
#include "etsi_its_denm_ts_msgs/msg/detail/sensor_types__struct.h"
// Member 'used_stored_information'
#include "etsi_its_denm_ts_msgs/msg/detail/stored_information_type__struct.h"
// Member 'confidence_value'
#include "etsi_its_denm_ts_msgs/msg/detail/confidence_level__struct.h"

/// Struct defined in msg/MetaInformation in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__MetaInformation
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF provides information about the source of and confidence in information.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field usedDetectionInformation: the type of sensor(s) that is used to provide the detection information.
  ///  *
  ///  * @field usedStoredInformation: the type of source of the stored information.
  ///  *
  ///  * @field confidenceValue: an optional confidence value associated to the information.
  ///  *
  ///  * @category: Basic information
  ///  * @revision: Created in V2.2.1
  /// */
  /// MetaInformation::=SEQUENCE{
  ///   usedDetectionInformation   SensorTypes,
  ///   usedStoredInformation      StoredInformationType,
  ///   confidenceValue            ConfidenceLevel OPTIONAL,
  ///   ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_ts_msgs__msg__SensorTypes used_detection_information;
  etsi_its_denm_ts_msgs__msg__StoredInformationType used_stored_information;
  etsi_its_denm_ts_msgs__msg__ConfidenceLevel confidence_value;
  bool confidence_value_is_present;
} etsi_its_denm_ts_msgs__msg__MetaInformation;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__MetaInformation.
typedef struct etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence
{
  etsi_its_denm_ts_msgs__msg__MetaInformation * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__MetaInformation__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__META_INFORMATION__STRUCT_H_
