// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/PosLonCarr.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__POS_LON_CARR__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__POS_LON_CARR__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_denm_ts_msgs__msg__PosLonCarr__MIN = 1
};

/// Constant 'MAX'.
enum
{
  etsi_its_denm_ts_msgs__msg__PosLonCarr__MAX = 127
};

/// Constant 'OUT_OF_RANGE'.
enum
{
  etsi_its_denm_ts_msgs__msg__PosLonCarr__OUT_OF_RANGE = 126
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_denm_ts_msgs__msg__PosLonCarr__UNAVAILABLE = 127
};

/// Struct defined in msg/PosLonCarr in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__PosLonCarr
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the distance from the centre of vehicle front bumper to the right or left longitudinal carrier of vehicle.
  ///  * The left/right carrier refers to the left/right as seen from a passenger sitting in the vehicle.
  ///  *
  ///  * The value shall be set to:
  ///  * - `n` (`n > 0` and `n < 126`) for any aplicable value between 0,01 metre and 1,26 metres,
  ///  * - `126` for values equal to or higher than 1.25 metres,
  ///  * - `127` if the information is unavailable.
  ///  *
  ///  * @unit 0,01 metre
  ///  * @category Vehicle information
  ///  * @revision: description revised in V2.1.1 (the meaning of 126 has changed slightly)
  ///  */
  /// PosLonCarr ::= INTEGER {
  ///     outOfRange  (126),
  ///     unavailable (127)
  /// } (1..127)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_denm_ts_msgs__msg__PosLonCarr;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__PosLonCarr.
typedef struct etsi_its_denm_ts_msgs__msg__PosLonCarr__Sequence
{
  etsi_its_denm_ts_msgs__msg__PosLonCarr * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__PosLonCarr__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__POS_LON_CARR__STRUCT_H_
