// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/Provider.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PROVIDER__STRUCT_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PROVIDER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'country_code'
#include "etsi_its_denm_ts_msgs/msg/detail/country_code__struct.hpp"
// Member 'provider_identifier'
#include "etsi_its_denm_ts_msgs/msg/detail/issuer_identifier__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__Provider __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__Provider __declspec(deprecated)
#endif

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Provider_
{
  using Type = Provider_<ContainerAllocator>;

  explicit Provider_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : country_code(_init),
    provider_identifier(_init)
  {
    (void)_init;
  }

  explicit Provider_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : country_code(_alloc, _init),
    provider_identifier(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _country_code_type =
    etsi_its_denm_ts_msgs::msg::CountryCode_<ContainerAllocator>;
  _country_code_type country_code;
  using _provider_identifier_type =
    etsi_its_denm_ts_msgs::msg::IssuerIdentifier_<ContainerAllocator>;
  _provider_identifier_type provider_identifier;

  // setters for named parameter idiom
  Type & set__country_code(
    const etsi_its_denm_ts_msgs::msg::CountryCode_<ContainerAllocator> & _arg)
  {
    this->country_code = _arg;
    return *this;
  }
  Type & set__provider_identifier(
    const etsi_its_denm_ts_msgs::msg::IssuerIdentifier_<ContainerAllocator> & _arg)
  {
    this->provider_identifier = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_denm_ts_msgs::msg::Provider_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_ts_msgs::msg::Provider_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::Provider_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::Provider_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::Provider_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::Provider_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::Provider_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::Provider_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::Provider_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::Provider_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__Provider
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::Provider_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__Provider
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::Provider_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Provider_ & other) const
  {
    if (this->country_code != other.country_code) {
      return false;
    }
    if (this->provider_identifier != other.provider_identifier) {
      return false;
    }
    return true;
  }
  bool operator!=(const Provider_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Provider_

// alias to use template instance with default allocator
using Provider =
  etsi_its_denm_ts_msgs::msg::Provider_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PROVIDER__STRUCT_HPP_
