// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_denm_ts_msgs:msg/RoadConfigurationSection.idl
// generated code does not contain a copyright notice
#include "etsi_its_denm_ts_msgs/msg/detail/road_configuration_section__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `road_section_definition`
#include "etsi_its_denm_ts_msgs/msg/detail/road_section_definition__functions.h"
// Member `road_type`
#include "etsi_its_denm_ts_msgs/msg/detail/road_type__functions.h"
// Member `lane_configuration`
#include "etsi_its_denm_ts_msgs/msg/detail/basic_lane_configuration__functions.h"
// Member `mapem_configuration`
#include "etsi_its_denm_ts_msgs/msg/detail/mapem_configuration__functions.h"

bool
etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__init(etsi_its_denm_ts_msgs__msg__RoadConfigurationSection * msg)
{
  if (!msg) {
    return false;
  }
  // road_section_definition
  if (!etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__init(&msg->road_section_definition)) {
    etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__fini(msg);
    return false;
  }
  // road_type
  if (!etsi_its_denm_ts_msgs__msg__RoadType__init(&msg->road_type)) {
    etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__fini(msg);
    return false;
  }
  // road_type_is_present
  // lane_configuration
  if (!etsi_its_denm_ts_msgs__msg__BasicLaneConfiguration__init(&msg->lane_configuration)) {
    etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__fini(msg);
    return false;
  }
  // lane_configuration_is_present
  // mapem_configuration
  if (!etsi_its_denm_ts_msgs__msg__MapemConfiguration__init(&msg->mapem_configuration)) {
    etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__fini(msg);
    return false;
  }
  // mapem_configuration_is_present
  return true;
}

void
etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__fini(etsi_its_denm_ts_msgs__msg__RoadConfigurationSection * msg)
{
  if (!msg) {
    return;
  }
  // road_section_definition
  etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__fini(&msg->road_section_definition);
  // road_type
  etsi_its_denm_ts_msgs__msg__RoadType__fini(&msg->road_type);
  // road_type_is_present
  // lane_configuration
  etsi_its_denm_ts_msgs__msg__BasicLaneConfiguration__fini(&msg->lane_configuration);
  // lane_configuration_is_present
  // mapem_configuration
  etsi_its_denm_ts_msgs__msg__MapemConfiguration__fini(&msg->mapem_configuration);
  // mapem_configuration_is_present
}

bool
etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__are_equal(const etsi_its_denm_ts_msgs__msg__RoadConfigurationSection * lhs, const etsi_its_denm_ts_msgs__msg__RoadConfigurationSection * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // road_section_definition
  if (!etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__are_equal(
      &(lhs->road_section_definition), &(rhs->road_section_definition)))
  {
    return false;
  }
  // road_type
  if (!etsi_its_denm_ts_msgs__msg__RoadType__are_equal(
      &(lhs->road_type), &(rhs->road_type)))
  {
    return false;
  }
  // road_type_is_present
  if (lhs->road_type_is_present != rhs->road_type_is_present) {
    return false;
  }
  // lane_configuration
  if (!etsi_its_denm_ts_msgs__msg__BasicLaneConfiguration__are_equal(
      &(lhs->lane_configuration), &(rhs->lane_configuration)))
  {
    return false;
  }
  // lane_configuration_is_present
  if (lhs->lane_configuration_is_present != rhs->lane_configuration_is_present) {
    return false;
  }
  // mapem_configuration
  if (!etsi_its_denm_ts_msgs__msg__MapemConfiguration__are_equal(
      &(lhs->mapem_configuration), &(rhs->mapem_configuration)))
  {
    return false;
  }
  // mapem_configuration_is_present
  if (lhs->mapem_configuration_is_present != rhs->mapem_configuration_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__copy(
  const etsi_its_denm_ts_msgs__msg__RoadConfigurationSection * input,
  etsi_its_denm_ts_msgs__msg__RoadConfigurationSection * output)
{
  if (!input || !output) {
    return false;
  }
  // road_section_definition
  if (!etsi_its_denm_ts_msgs__msg__RoadSectionDefinition__copy(
      &(input->road_section_definition), &(output->road_section_definition)))
  {
    return false;
  }
  // road_type
  if (!etsi_its_denm_ts_msgs__msg__RoadType__copy(
      &(input->road_type), &(output->road_type)))
  {
    return false;
  }
  // road_type_is_present
  output->road_type_is_present = input->road_type_is_present;
  // lane_configuration
  if (!etsi_its_denm_ts_msgs__msg__BasicLaneConfiguration__copy(
      &(input->lane_configuration), &(output->lane_configuration)))
  {
    return false;
  }
  // lane_configuration_is_present
  output->lane_configuration_is_present = input->lane_configuration_is_present;
  // mapem_configuration
  if (!etsi_its_denm_ts_msgs__msg__MapemConfiguration__copy(
      &(input->mapem_configuration), &(output->mapem_configuration)))
  {
    return false;
  }
  // mapem_configuration_is_present
  output->mapem_configuration_is_present = input->mapem_configuration_is_present;
  return true;
}

etsi_its_denm_ts_msgs__msg__RoadConfigurationSection *
etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__RoadConfigurationSection * msg = (etsi_its_denm_ts_msgs__msg__RoadConfigurationSection *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__RoadConfigurationSection), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_denm_ts_msgs__msg__RoadConfigurationSection));
  bool success = etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__destroy(etsi_its_denm_ts_msgs__msg__RoadConfigurationSection * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence__init(etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__RoadConfigurationSection * data = NULL;

  if (size) {
    data = (etsi_its_denm_ts_msgs__msg__RoadConfigurationSection *)allocator.zero_allocate(size, sizeof(etsi_its_denm_ts_msgs__msg__RoadConfigurationSection), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence__fini(etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence *
etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence * array = (etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence__destroy(etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence__are_equal(const etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence * lhs, const etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence__copy(
  const etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence * input,
  etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_denm_ts_msgs__msg__RoadConfigurationSection);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_denm_ts_msgs__msg__RoadConfigurationSection * data =
      (etsi_its_denm_ts_msgs__msg__RoadConfigurationSection *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
